//----------------------------------------------------------------------------

//  

//-----------------------  : ------------------------------

// TControl   .   
//     .  Execute 
//  ,       ,  
//    .

//----------------------------------------------------------------------------

#include "main.hpp"
#include "control.hpp"

//----------------------------------------------------------------------------
//----------------------------  TControl: -------------------------------
//----------------------------------------------------------------------------

//----------------------------- : ---------------------------------

TControl::TControl(void)
{
  // :
  HardwareInit();
  // :
#ifdef PINOUT_005
  Pin_PlayF.DirOut();
  Pin_PlayR.DirOut();
  Pin_Rec.DirOut();
  Pin_Ffd.DirOut();
  Pin_Rew.DirOut();
  Pin_Pause.DirOut();
  Pin_Stop.DirOut();
  Pin_Repeat.DirOut();
#else
  Pin_PlayF.DirTri();
  Pin_PlayR.DirTri();
  Pin_Rec.DirTri();
  Pin_Ffd.DirTri();
  Pin_Rew.DirTri();
  Pin_Pause.DirTri();
  Pin_Stop.DirTri();
  Pin_Repeat.DirTri();
#endif
  //  :
  Keyboard = new TKeyboard();
}

//------------------------  : ----------------------------

void TControl::Execute(void)
{
  if(TSysTimer::Tick)
  {
    uint8_t code = Keyboard->Code(); //  
    OutsControl(code);   // 
    if(Keyboard->Done()) //   ,
    __sleep();           //  Power Down
  }
}

//----------------------------------------------------------------------------
//-------------------------  : --------------------------
//----------------------------------------------------------------------------

//-------------------------  : --------------------------

inline void TControl::HardwareInit(void)
{
  //  :
  Pin_PB3.DirIn(PIN_PULL);
  Pin_PB4.DirIn(PIN_PULL);
  Pin_PB5.DirIn(PIN_PULL);
  Pin_PC0.DirIn(PIN_PULL);
  Pin_PC1.DirIn(PIN_PULL);
  Pin_PC2.DirIn(PIN_PULL);
  Pin_PC3.DirIn(PIN_PULL);
  Pin_PC4.DirIn(PIN_PULL);
  Pin_PC5.DirIn(PIN_PULL);
  Pin_PD0.DirIn(PIN_PULL);
  Pin_PD3.DirIn(PIN_PULL);
  Pin_PD4.DirIn(PIN_PULL);
  //  :
  ACSR = (1 << ACD);
}

//--------------------------  : ----------------------------

inline void TControl::OutsControl(uint8_t code)
{
#ifdef PINOUT_005
  Pin_Rec = (code == KEY_REC);
  Pin_PlayF = (code == KEY_PLAYF || code == KEY_REC);
  Pin_PlayR = (code == KEY_PLAYR);
  Pin_Ffd = (code == KEY_FFD);
  Pin_Rew = (code == KEY_REW);
  Pin_Pause = (code == KEY_PAUSE);
  Pin_Stop = (code == KEY_STOP);
  Pin_Repeat = (code == KEY_ROLL);
#else
  Pin_Rec.Tri(code != KEY_REC);
  Pin_PlayF.Tri(code != KEY_PLAYF && code != KEY_REC);
  Pin_PlayR.Tri(code != KEY_PLAYR);
  Pin_Ffd.Tri(code != KEY_FFD);
  Pin_Rew.Tri(code != KEY_REW);
  Pin_Pause.Tri(code != KEY_PAUSE);
  Pin_Stop.Tri(code != KEY_STOP);
  Pin_Repeat.Tri(code != KEY_ROLL);
#endif
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
