//----------------------------------------------------------------------------

// 

//----------------------------------------------------------------------------

#include "main.hpp"
#include "keyboard.hpp"

//----------------------    : ------------------------

#ifdef RC5
  //#include "remcodes_h59tt.hpp" //my old
  #include "remcodes_rme195.hpp" //my new
  //#include "remcodes_rc63cd.hpp"
  //#include "remcodes_evg_k.hpp"
#endif
#ifdef NEC
  #include "remcodes_rc15a.hpp"
#endif

//----------------------------- : -----------------------------------

#ifdef RC5
  #define REP_TM      120 //  , 
  #define CMD_MAX    0x3F //   RC-5
  #define SYS_NUM    (REM_Codes[0]) //    
  #define KEY_NUM(x) (REM_Codes[(x) + 1]) //    
#endif
#ifdef NEC
  #define REP_TM      120 //  , 
  #define CMD_MAX    0xFE //   NEC
  #define SYS_NUM    (REM_Codes[0] | ((uint16_t)REM_Codes[1] << 8))
  #define KEY_NUM(x) (REM_Codes[(x) + 2])
#endif

#define HLD_TM 2000 //   "", 

//----------------------------------------------------------------------------
//---------------------------  TKeyboard: -------------------------------
//----------------------------------------------------------------------------

//----------------------------- : ---------------------------------

TKeyboard::TKeyboard(void)
{
#pragma diag_suppress=Pa082
  Remote = new TRemote(SYS_NUM);      //  
#pragma diag_warning=Pa082
  RemTimer = new TSoftTimer(REP_TM);  //  
  RemTimer->Force();
  HoldTimer = new TSoftTimer(HLD_TM); //   ""
  HoldTimer->Force();
  Prev_Cmd = REM_NO;                  //  
}

//-----------------------   : --------------------------

uint8_t TKeyboard::Code(void)
{
  static bool Hold = 0;         //  
  uint8_t res = REM_NO;         //
  uint8_t c = Remote->GetCom(); // 

  if(c != REM_NO)               //  
  {
    RemTimer->Start();          // 
    if(c == Prev_Cmd)           // ,
      res = c;                  //  
  }
  else                          //  
  {
    c = Prev_Cmd;               //  
    if(RemTimer->Over())        //  ,
    {
      c = REM_NO;               //  
    }
    else                        // 
    {
      res = c;                  // 
    }
  }
  Prev_Cmd = c;                 //  
#ifdef RC5
  res = res & ~RC5_CB;          // CB
#endif
  if(res > CMD_MAX) res = NC;   //  ,   
    else res = KEY_NUM(res);    //
  if(res == KEY_RECD)           //   
  {
    if(!Hold)
    {
      HoldTimer->Start();       // 
      Hold = 1;
    }
    if(!HoldTimer->Over())      //   ,
      res = NC;                 // 
        else res = KEY_REC;
  }
  else
  {
    Hold = 0;                   //  
  }
  return(res);
}

//-------------------------  : -------------------------------

bool TKeyboard::Done(void)
{
  return(RemTimer->Over());
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
