//----------------------------------------------------------------------------

// ,  

//----------------------------------------------------------------------------

#ifndef MAIN_HPP
#define MAIN_HPP

//----------------------------------------------------------------------------

#include <iom88.h>
#include <intrinsics.h>
#include <stdint.h>
#include <stdbool.h>
#include "systimer.hpp"
#include "gpio.hpp"

//--------------------------  : -------------------------------

#define VERSION 202
#define PINOUT_005     //   -005
//#define PINOUT_004     //   -004
//#define PINOUT_003     //   -003

//------------------   : -----------------------

#ifdef PINOUT_004
  typedef TGpio<PORT_B, PIN_6> Pin_Rec_t;    //PB5 - Rec    [control]
  typedef TGpio<PORT_B, PIN_7> Pin_Stop_t;   //PB5 - Stop   [control]
  typedef TGpio<PORT_D, PIN_5> Pin_PlayF_t;  //PD5 - PlayF  [control]
  typedef TGpio<PORT_D, PIN_6> Pin_Ffd_t;    //PD6 - Ffd    [control]
  typedef TGpio<PORT_D, PIN_7> Pin_Rew_t;    //PD7 - Rew    [control]
  typedef TGpio<PORT_B, PIN_0> Pin_PlayR_t;  //PB0 - PlayR  [control]
  typedef TGpio<PORT_B, PIN_1> Pin_Pause_t;  //PB1 - Pause  [control]
  typedef TGpio<PORT_B, PIN_2> Pin_Repeat_t; //PB2 - Repeat [control]
#endif
#ifdef PINOUT_003
  typedef TGpio<PORT_B, PIN_6> Pin_Pause_t;  //PB5 - Pause  [control]
  typedef TGpio<PORT_B, PIN_7> Pin_Repeat_t; //PB5 - Repeat [control]
  typedef TGpio<PORT_D, PIN_5> Pin_Rew_t;    //PD5 - Rew    [control]
  typedef TGpio<PORT_D, PIN_6> Pin_PlayR_t;  //PD6 - PlayR  [control]
  typedef TGpio<PORT_D, PIN_7> Pin_Rec_t;    //PD7 - Rec    [control]
  typedef TGpio<PORT_B, PIN_0> Pin_Stop_t;   //PB0 - Stop   [control]
  typedef TGpio<PORT_B, PIN_1> Pin_Ffd_t;    //PB1 - Ffd    [control]
  typedef TGpio<PORT_B, PIN_2> Pin_PlayF_t;  //PB2 - PlayF  [control]
#endif
#ifdef PINOUT_005
  typedef TGpio<PORT_B, PIN_6> Pin_Pause_t;  //PB5 - Pause  [control]
  typedef TGpio<PORT_B, PIN_7> Pin_Rew_t;    //PB5 - Rew    [control]
  typedef TGpio<PORT_D, PIN_5> Pin_Rec_t;    //PD5 - Rec    [control]
  typedef TGpio<PORT_D, PIN_6> Pin_PlayR_t;  //PD6 - PlayR  [control]
  typedef TGpio<PORT_D, PIN_7> Pin_PlayF_t;  //PD7 - PlayF  [control]
  typedef TGpio<PORT_B, PIN_0> Pin_Stop_t;   //PB0 - Stop   [control]
  typedef TGpio<PORT_B, PIN_1> Pin_Ffd_t;    //PB1 - Ffd    [control]
  typedef TGpio<PORT_B, PIN_2> Pin_Repeat_t; //PB2 - Repeat [control]
#endif

typedef TGpio<PORT_D, PIN_1> Pin_LED_t;  //PD1 - LED [remote]
typedef TGpio<PORT_D, PIN_2> Pin_IR_t;   //PD2 (INT0) - IR [remote]

typedef TGpio<PORT_B, PIN_3> Pin_PB3_t;  //PB3 - Not Used [control]
typedef TGpio<PORT_B, PIN_4> Pin_PB4_t;  //PB4 - Not Used [control]
typedef TGpio<PORT_B, PIN_5> Pin_PB5_t;  //PB5 - Not Used [control]

typedef TGpio<PORT_C, PIN_0> Pin_PC0_t;  //PC0 - Not Used [control]
typedef TGpio<PORT_C, PIN_1> Pin_PC1_t;  //PC1 - Not Used [control]
typedef TGpio<PORT_C, PIN_2> Pin_PC2_t;  //PC2 - Not Used [control]
typedef TGpio<PORT_C, PIN_3> Pin_PC3_t;  //PC3 - Not Used [control]
typedef TGpio<PORT_C, PIN_4> Pin_PC4_t;  //PC4 - Not Used [control]
typedef TGpio<PORT_C, PIN_5> Pin_PC5_t;  //PC5 - Not Used [control]

typedef TGpio<PORT_D, PIN_0> Pin_PD0_t;  //PD0 - Not Used [control]
typedef TGpio<PORT_D, PIN_3> Pin_PD3_t;  //PD3 - Not Used [control]
typedef TGpio<PORT_D, PIN_4> Pin_PD4_t;  //PD4 - Not Used [control]

//--------------    : -----------------

//Timer0: system timer                   : systimer.hpp
//Timer1: NOT USED                       -
//Timer2: IR decoder                     : remote.hpp
//SPI: NOT USED                          -
//USART: NOT USED                        -
//TWI: NOT USED                          -
//ADC: NOT USED                          -
//Comparator: NOT USED                   -

//-----------------------  : --------------------------

//INT0: IR receiver                      : remote.hpp
//TIMER0_COMPA: System tick              : systimer.hpp
//TIMER2_OVF: IR decoder                 : remote.hpp

//----------------------------------------------------------------------------

#endif
