//----------------------------------------------------------------------------

//    ,  

//----------------------------------------------------------------------------

#ifndef REMOTE_HPP
#define REMOTE_HPP

//----------------------------- : -----------------------------------

#define REM_NO 0xFF //  
#define RC5_CB 0x80 //RC-5 control bit   

//----------------------------------------------------------------------------
//----------------------------  TRemote: --------------------------------
//----------------------------------------------------------------------------

#pragma vector = INT0_vect
extern "C" __interrupt void InputIR(void); // 
#pragma vector = TIMER2_OVF_vect
extern "C" __interrupt void TimerIR(void); // 

class TRemote
{
  friend __interrupt void InputIR(void);
  friend __interrupt void TimerIR(void);
private:
  static Pin_IR_t Pin_IR;   // 
  static Pin_LED_t Pin_LED; // 
  uint16_t SysUsed;
  static uint8_t volatile State;
  static uint16_t volatile System;
  static uint8_t volatile Command;
#ifdef RC5
  static void TmrIntEnable(uint8_t delay);
  static void TmrIntDisable(void);
  static void ExtInt0Enable(void);
  static void ExtIntEnable(void);
  static void ExtIntDisable(void);
#endif
public:
  TRemote(uint16_t sys);
  uint8_t GetCom(void); //  
};

//----------------------------------------------------------------------------

#endif
